*****************************************************************************
* Name:         The Note Filer Aplet for the HP39/40G
* Language:     RPL
* Author:       Jordi Hidalgo (johil@tv3mail.com)
* Copyright:    (c) 2002 by Jordi Hidalgo Lozano. All rights reserved.
* Versions:     Beta 0.1 [38/--/--] - Sep 05, 2002
*               Beta 0.2 [38/39/40] - Sep 09, 2002
*               Beta 0.3 [--/39/40] - Oct 22, 2002
*****************************************************************************

TITLE NoteFiler

INCLUDE common39.h

ASSEMBLE
        Dir_Head 10,Note Filer,7FF
RPL

EXTERNAL view7_CAPLET

{
 topic_CAPLET
 view01_CAPLET
 view23_CAPLET
 view45_CAPLET
 xREADNOTE
 view7_CAPLET
}

INCLUDE share39.h

ASSEMBLE
        Vfield  L34,IntTable
        CON(5)  =DOHSTR
        REL(5)  endLink
        Link    _Main
        Link    _Entry
        Link    _Action
        Link    _ViewNote
        Link    _CreateFolder
        Link    _AddNote
        Link    _GetFName
        Link    _ChooseFolder
        Link    _ChFolder.1
        Link    _Add
        Link    _GetValNotes
        Link    _DelFolder
        Link    _DelNote
        Link    _DelItem
        Link    _GetItems
        Link    _GetItems.1
        Link    _FPTR3
        Link    _HP40G?
endLink
RPL

DEFINE  Main            INT_00
DEFINE  Entry           INT_01
DEFINE  Action          INT_02
DEFINE  ViewNote        INT_03
DEFINE  CreateFolder    INT_04
DEFINE  AddNote         INT_05
DEFINE  GetFName        INT_06
DEFINE  ChooseFolder    INT_07
DEFINE  ChFolder.1      INT_08
DEFINE  Add             INT_09
DEFINE  GetValNotes     INT_0A
DEFINE  DelFolder       INT_0B
DEFINE  DelNote         INT_0C
DEFINE  DelItem         INT_0D
DEFINE  GetItems        INT_0E
DEFINE  GetItems.1      INT_0F
DEFINE  FPTR3           INT_10
DEFINE  HP40G?          INT_11
DEFINE  Folders@        LastBut4
DEFINE  Folders!        ListOfEqs!
DEFINE  2NULLLAM{}      { NULLLAM NULLLAM }
DEFINE  ONE{}N          :: ONE {}N ;

ASSEMBLE
        Vfield  IntTable,DirVar
RPL
ASSEMBLE
        CON(5)  =DOHSTR
        REL(5)  endCode
RPL

ASSEMBLE
=TRAVERSE+      EQU     #08D0F
=GPPushT/FLp    EQU     #0DD87
=matchob?       EQU     #0ECD8
=FPointer       EQU     #177C7
=ListOfEqs!     EQU     #273C1
=NotesDisp      EQU     #3F71A
=NotesExit0     EQU     #3F71C
=NotesHKeys     EQU     #3F71D
=NotesInit0     EQU     #3F71F
=NotesSKeys     EQU     #3F7A3
=LEDone         EQU     #6C1B4 (3)
=LEQuit         EQU     #6C1D2 (3)
=EndChooseOK    EQU     #6C385 (3)
=ApNameFP       EQU     #7D03F (3)
=ApNameEdSKey   EQU     #7D076 (3)
=USEROB         EQU     #80711
RPL

NAMELESS _Main
::
 HP40G?
 ITE
 $ "HP40G"
 $ "HP39G"
 $ " NOTE FILER for " OVER &$
 $ "\n Version \DF0.3 (BETA!)\n\n   by Jordi Hidalgo\n  (johil@tv3mail.com)\n       (C) 2002"
 &$
 LastBut1 REPLACE DROP
 $ "My " SWAP&$
 ONE
 Folders@
 PUTLIST
 Folders!
 {
  MINUSONE
  {
   { $ "Start" :: ZERO INT_00 ; }
   { $ "Reset" :: EIGHT INT_00 ; }
   { $ "About" NotesViewUI }
  }
  StndVar
  StndEntry
  StndExit
 }
 BinLookup case EVAL
 EIGHT #= IT
 ::
  $ "Reset aplet Note Filer?"
  DoQueryBox
  NOT?SEMI
  HP40G? ITE { $ "My HP40G" } { $ "My HP39G" } Folders!
 ;

 ' Entry
 ' LeaveGraphView
 ' :: DA3OK?NOTIT ?DispMenu EnsureMenuOff ;
 '
 ::
  {
   { kcEnter :: TakeOver Action ; }
   NULL{}
   NULL{}
   NULL{}
   NULL{}
   NULL{}
  }
  ONE KeyFace
 ;
 StndMenu
;

NAMELESS _Entry
::
 TURNMENUOFF
 RECLAIMDISP
 THIRTYTHREE
 ZERO
 ASSEMBLE
        CON(5)  =DOGROB
        CON(5)  #48F
        CON(5)  #40
        CON(5)  #41
        NIBHEX 000000000000000000000000000002000000000000CF300E000000000000FF70
        NIBHEX 0F100000000008FE700F300000000008FC708F3000000000ECFF708F30000000
        NIBHEX 08F8FF70CF360000004CF9F100CF3F000000EEFBFD70CFBF100000F7F3F970EF
        NIBHEX FF300000F3F7F970EFFF300008F7E7EF30FDFF10000CFFCFCF10FEF7000000FF
        NIBHEX 9F0008FEF3000000CFBF10007EF100000F8F3F00000F7C3000070E7200000F3E
        NIBHEX 7000870CF000000E1FF0008300F0000004CFF000830040000000EFF100CF3000
        NIBHEX 000000FF9100CFF000000000F3C100CFF70000000070C100CFFF100000006FF1
        NIBHEX 00EFFF10000000EFF100EFFF10000000EFF100E00F00000000CFF000E0000000
        NIBHEX 00000F3000E000000000000003000000000000008FFF000F0000000000CFFF00
        NIBHEX 0F0000000000CFFF000F9F00000000CFFF000FFF10000000EFFF000FFF100000
        NIBHEX 006EFF000FFF100000000087000EF300000000E181000EF000000000F781000E
        NIBHEX 3C70000008FF30000C0EF000000CFF700000CDF100000CDF700000EFD100000C
        NIBHEX 3F700000FBD300000C7F700000F7C300000CB1700000FFF3300008D3300000ED
        NIBHEX F9F00C18EF300000ECF9FE1E10FF100000CFFD7E1E30EF0000008FFE7E1E3083
        NIBHEX 0000000FFE7F1C70000000000E3F3F1C7000000000008F3F1CF000000000008F
        NIBHEX 3F9FF00000000000CF9F9FF10000000000EF9F9FF10000000000EF8F18F30000
        NIBHEX 000000EF8F18F30000000000CFCF18F700000000000740CFF3000000000000CF
        NIBHEX DF700000000000008F9700000000000000000000000000000000000000000000
 RPL
 XYGROBDISP
 FIFTYONE
 TWENTYSIX
 $ "ENTER"
 $>BIGGROB
 XYGROBDISP
;

NAMELESS _Action
::
 '
 ::
  83 #=casedrop
  ::
   '
   ::
    NoExitAction
    {
     NullMenuKey
     NullMenuKey
     NullMenuKey
     NullMenuKey
     {
      $ "QUIT"
      :: TakeOver ' LEQuit FPTR3 NOTcase SetDAsNoCh FALSETRUE TOLVar5! ;
     }
     {
      $ "OK"
      :: TakeOver ' LEDone FPTR3 NOTcase SetDAsNoCh ' EndChooseOK FPTR3 ;
     }
    }
   ;
   TRUE
  ;
  DROPFALSE
 ;
 $ "Note Filer"
 SEVENTEEN
 {
  { $ "View Note" :: Folders@ COLA ViewNote ; }
  { $ "Create Folder" :: CreateFolder COLA Entry ; }
  { $ "Add Notes" AddNote }
  { $ "Delete Item" DelItem }
 }
 ONE
 Choose
 NOT?SEMI
 TWO NTHCOMPDROP EVAL
 COLA Action
;

NAMELESS _ViewNote
::
 'DROPFALSE
 OVER
 CARCOMP
 $ "Items in "
 SWAP&$
 '
 ::
  DUPTYPECSTR?
  ?SEMI
  CARCOMP
 ;
 4ROLL
 CDRCOMP
 ONE
 Choose
 NOT?SEMI
 DUPTYPELIST?
 NOTcase
 ::
  $>ID
  DUP
  CatNot {}N
  matchob?
  NOTcasedrop
  ::
   ID>$
   DUP
   $ "No "
   SWAP&$
   $ " in Notepad. Delete item?"
   &$
   DoAlert&Quer
   NOTcaseDROP
   1LAMBIND
   Folders@
   DelNote
   ABND
   Folders!
  ;
  RDROP
  '
  ID 'CurNote
  STO
  ?ExitThisTop
  'NOP
  'NOP
  '
  ::
   :: ' ID 'CurNote @ ?SEMI ' ID NOTE ;
   DUP
   DoInNotCxt
   :: ID>$ tok' SWAP &$ $>ID @ ;
   ?SKIP
   NULL$
   OVER
   DoInNotCxt
   :: ID>$ tok; SWAP&$ $>ID @ ;
   ?SKIP
   ONE
   ROT
   ID>$
   $ " NOTE"
   &$
   NotesInit0
  ;
  '
  ::
   '
   ::
    :: ' ID 'CurNote @ ?SEMI ' ID NOTE ;
    DoInNotCxt
    :: ID>$ tok; SWAP&$ $>ID STO ;
    :: ' ID 'CurNote @ ?SEMI ' ID NOTE ;
    DoInNotCxt
    :: ID>$ tok' SWAP &$ $>ID STO ;
   ;
   NotesExit0
  ;
  ' NotesDisp FPointer
  ' NotesHKeys FPointer
  TRUE
  NotesSKeys
  ONE
  'ERRJMP
  TOLSetTopicU
 ;
 COLA ViewNote
;

NAMELESS _CreateFolder
::
 GetFName
 DA3OK?NOTIT ?DispMenu
 NOT?SEMI
 DUPNULL$?
 caseDROP
 GetItems
 matchob?
 case
 ::
  $ "Duplicate item"
  DoAlert
 ;
 ChooseFolder
 NOTcaseDROP
 Folders@
 UNROT
 2NULLLAM{}
 BIND
 Add
 Folders!
 $ "Add notes to "
 2GETLAM &$ "?" &$
 DoQueryBox
 NOTcase
 ABND
 GetValNotes
 NOTcase
 ABND
 2GETLAM
 1PUTLAM
 2PUTLAM
 Folders@
 Add
 ABND
 Folders!
;

NAMELESS _AddNote
::
 GetValNotes
 NOT?SEMI
 ChooseFolder
 NOTcaseDROP
 Folders@
 UNROT
 2NULLLAM{}
 BIND
 Add
 ABND
 Folders!
;

NAMELESS _GetFName
::
 $ "Name:"
 ONE
 NINETEEN
 ' :: ' ApNameFP FPTR3 ;
 THIRTYONE
 SEVENTEEN
 BINT_91d
 NINE
 ONE
 MINUSTWO
 ONE
 $ "Enter name for new folder"
 MINUSONE
 MINUSONE
 NULL$
 NULL$
 ONE
 ONE
 '
 ::
  FIFTEEN
  #=
  NOTcaseFALSE
  :: ' ApNameEdSKey FPTR3 ;
 ;
 $ "New Folder"
 DoInputForm
;

NAMELESS _ChooseFolder
::
 'DROPFALSE
 $ "Choose Folder"
 ONE
 NULL{}
 1LAMBIND
 Folders@
 ChFolder.1
 1GETABND
 ONE
 Choose
;

NAMELESS _ChFolder.1
::
 DUP
 CARCOMP
 1GETSWAP
 >TCOMP
 1PUTLAM
 CDRCOMP
 DUPNULLCOMP?
 caseDROP
 INNERCOMP
 reversym
 ZERO_DO (DO)
 DUPTYPELIST?
 NOT
 ITE_DROP
 ChFolder.1
 LOOP
;

NAMELESS _Add
::
 DUP
 CARCOMP
 1GETLAM
 EQUAL
 IT
 ::
  2GETLAM
  dLISTcase
  &COMP
  ONE{}N
  >TCOMP
 ;
 DUPLENCOMP
 NULL$SWAP
 NDUPN
 {}N
 SWAP
 toLEN_DO (DO)
 DUPINDEX@
 NTHCOMPDROP
 DUPTYPECSTR?
 ?SKIP
 Add
 ROT
 INDEX@
 SWAP
 PUTLIST
 SWAP
 LOOP
 DROP
;

NAMELESS _GetValNotes
::
 '
 ::
  SIXTYONE #=casedrop TrueTrue
  SEVENTY #=casedrop
  ::
   TOLVar41@ LENCOMP
   ::
    ZERO #=casedrop $ "AVAILABLE NOTES"
    ONE  #=casedrop $ "1 NOTE PICKED"
    UNCOERCE EDITDECOMP$ $ " NOTES PICKED" &$
   ;
   TRUE
  ;
  83 #=casedrop
  ::
   '
   ::
    NoExitAction
    {
     NullMenuKey
     NullMenuKey
     {
      :: TakeOver grobCheckKey ;
      {
       :: TakeOver DoCKeyCheck LEDispPrompt ;
       :: TakeOver DoCKeyChAll LEDispPrompt ;
      }
     }
     NullMenuKey
     {
      $ "(AN(L"
      {
       :: TakeOver ' LEQuit FPTR3 NOTcase SetDAsNoCh FALSETRUE TOLVar5! ;
       :: TakeOver DoCKeyUnChAll LEDispPrompt ;
      }
     }
     {
      $ "OK"
       {
        :: TakeOver ' LEDone FPTR3 NOTcase SetDAsNoCh ' EndChooseOK FPTR3 ;
        :: TakeOver DoCKeyChAll LEDispPrompt ;
       }
     }
    }
   ;
   TRUE
  ;
  DROPFALSE
 ;
 $ " "
 ONE
 CatNot
 DUP#0=ITE
 :: DROP NULL{} ;
 ::
  GetItems
  1LAMBIND
  pshzer
  DUP
  #1+_ONE_DO (DO)
  INDEX@
  #1+PICK
  ID>$
  1GETLAM
  matchob?
  ?SKIP
  psh1&
  LOOP
  NDROP
  {}N
  ABND
 ;
 ONE
 Choose
;

NAMELESS _DelFolder
::
 DUPLENCOMP
 NULL$SWAP
 NDUPN
 {}N
 SWAP
 toLEN_DO (DO)
 DUPINDEX@
 NTHCOMPDROP
 DUPTYPECSTR?
 ?SKIP
 ::
  DUP
  CARCOMP
  1GETLAM
  EQUAL
  ITE
  DROPZERO
  DelFolder
 ;
 ROT
 INDEX@
 SWAP
 PUTLIST
 SWAP
 LOOP
 DROPDUP
 ZERO
 EQUALPOSCOMP
 DUP#0=csDROP
 2DUP
 #1-1SWAP
 SUBCOMP
 UNROT
 #1+
 MINUSONE
 SUBCOMP
 &COMP
;

NAMELESS _DelNote
::
 DUP
 1GETLAM
 EQUALPOSCOMP
 ::
  DUP#0=csDROP
  2DUP
  #1-1SWAP
  SUBCOMP
  UNROT
  #1+
  MINUSONE
  SUBCOMP
  &COMP
 ;
 DUPLENCOMP
 NULL$SWAP
 NDUPN
 {}N
 SWAP
 toLEN_DO (DO)
 DUPINDEX@
 NTHCOMPDROP
 DUPTYPECSTR?
 ?SKIP
 DelNote
 ROT
 INDEX@
 SWAP
 PUTLIST
 SWAP
 LOOP
 DROP
;

NAMELESS _DelItem
::
 'DROPFALSE
 $ "Choose Item"
 ONE
 GetItems
 ONE
 Choose
 NOT?SEMI
 NULL{} 1LAMBIND Folders@ ChFolder.1 1GETABND
 OVER EQUALPOSCOMP
 #0=ITE
 ::
  1LAMBIND
  Folders@
  DelNote
  ABND
  Folders!
 ;
 ::
  $ "Delete folder\n"
  OVER &$ "?" &$
  DoQueryBox
  NOTcaseDROP
  DUP
  HP40G?
  ITE
  $ "My HP40G"
  $ "My HP39G"
  EQUAL
  ITE
  ONE{}N
  :: 1LAMBIND Folders@ DelFolder ABND ;
  Folders!
 ;
;

NAMELESS _GetItems
::
 NULL{}
 1LAMBIND
 Folders@
 GetItems.1
 1GETABND
;

NAMELESS _GetItems.1
::
 DUP
 CARCOMP
 1GETSWAP
 >TCOMP
 1PUTLAM
 CDRCOMP
 DUPNULLCOMP?
 caseDROP
 INNERCOMP
 reversym
 ZERO_DO (DO)
 DUPTYPECSTR?
 ITE
 :: 1GETSWAP >TCOMP 1PUTLAM ;
 GetItems.1
 LOOP
;

NAMELESS _FPTR3
ASSEMBLE
        NIBHEX  577203000000
RPL

NAMELESS _HP40G?
CODE
        GOSBVL  =SAVPTR
        D0=(5)  =USEROB
        A=DAT0  5
        D0=A
        D0=D0+  5
        C=DAT0  X
-       D0=D0+  13
        C=C-1   X
        GONC    -
        GOSBVL  =TRAVERSE+
        GOSBVL  =SKIPOB
        D0=D0+  7
        A=DAT0  12
        LCHEX   524944534143
        P=      11
        ?C=A    WP
        GOYES   +
+       GOVLNG  =GPPushT/FLp
ENDCODE

ASSEMBLE
endCode
RPL

ASSEMBLE
        Vfield DirVar,DirPar
RPL
{ $ "My HP39G" }

ASSEMBLE
        Vfield DirPar,DirCode
RPL
{ }

ASSEMBLE
        Vfield DirCode,DirAlt
RPL
{ }

ASSEMBLE
        Vfield DirAlt,DirNot
RPL
NULL$

ASSEMBLE
        Vfield DirNot,DirEnd
RPL
{ }
